#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>

#include "docint.h"
#include "icc.h"

static char *dev_name = NULL;

stub_hndlr(short cause, char masked)
{
	printf("stub_hndlr: Got cause %d mask %d\n", cause, masked);
/*	printf("stub_hndlr: mask_cause returns %d\n", mask_cause(cause, masked));*/
}


hndl_msg(ICC_context_t context)
{
	ICC_message_t *mp;
	ii_t ii;

	printf("Enter hndl_msg\n");
	while (1) {
		if (ICC_wait_message(context, &mp, ICC_TIMEOUT_FOREVER) == -1) {
			printf("maskc: Failed to wait for messages %d\n", errno);
			exit(-3);
		}

		memcpy(&ii, ICC_data_ptr(mp), sizeof(ii_t));
		ICC_dispose_message(mp);
		/* Call userland cause handler */
		stub_hndlr(ii.ii_inum, ii.ii_masked);
	}
}

usage(char *name)
{
	fprintf(stderr, "%s usage: -d dev-name -c context \n", name);
	exit(-1);
}

main(int argc, char **argv)
{
	int i;
	ICC_context_t context = -1;

	while ((i = getopt(argc, argv, "d:c:")) != -1)
		switch (i) {
		case 'd':
			dev_name = optarg;
			break;

		case 'c':
			if ((context = atoi(optarg)) < 0)
				usage(argv[0]);
			break;

		default:
			usage(argv[0]);
		}

	if (dev_name == NULL || context == -1)
		usage(argv[0]);

	if (ICC_init() == -1) {
		printf("maskc: failed to ICC_init\n", errno);
		exit(-2);
	}

	hndl_msg(context);
}
