/* -*- linux-c -*-
 * sysctl_net.c: sysctl interface to net subsystem.
 *
 * Begun April 1, 1996, Mike Shaver.
 * Added /proc/sys/net directories for each protocol family. [MS]
 *
 * $Log: sysctl_net.c,v $
 * Revision 1.1.1.1  2010/06/30 06:50:58  eating
 * TI PUMA5 VSDK1_1_3_42_GA 
 *
 * Revision 1.1.1.1  2009/05/22 16:26:59  jimmy
 * TI PUMA5 VSDK_1_1_3_36 
 *
 * Revision 1.1.1.1  2009/02/12 10:08:41  allen
 * Import TI source code, version 1.1.0.18
 *
 * Revision 1.1.1.1  2009/02/04 12:21:23  allen
 * Import TI source code, version 1.1.0.9
 *
 * Revision 1.1.1.1  2008/07/31 03:22:43  allen
 * Import new kernel for VSDK 1.0.0.11
 *
 * Revision 1.2  1996/05/08  20:24:40  shaver
 * Added bits for NET_BRIDGE and the NET_IPV4_ARP stuff and
 * NET_IPV4_IP_FORWARD.
 *
 *
 */

#include <linux/mm.h>
#include <linux/sysctl.h>

#include <net/sock.h>

#ifdef CONFIG_INET
#include <net/ip.h>
#endif

#ifdef CONFIG_NET
#include <linux/if_ether.h>
#endif

#ifdef CONFIG_TR
#include <linux/if_tr.h>
#endif

struct ctl_table net_table[] = {
	{
		.ctl_name	= NET_CORE,
		.procname	= "core",
		.mode		= 0555,
		.child		= core_table,
	},
#ifdef CONFIG_INET
	{
		.ctl_name	= NET_IPV4,
		.procname	= "ipv4",
		.mode		= 0555,
		.child		= ipv4_table
	},
#endif
#ifdef CONFIG_TR
	{
		.ctl_name	= NET_TR,
		.procname	= "token-ring",
		.mode		= 0555,
		.child		= tr_table,
	},
#endif
	{ 0 },
};
