<html>
<head>
    <meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
    <meta http-equiv="Pragma" content="no-cache">
    <title>Residential Gateway Configuration:</title>
    <style type="text/css">
        @import url(global.css);
    </style>
    <script language="javascript">

	function loadhelp(fname,anchname)
    {
        if(top.helpframe)
	    {
            top.helpframe.location.href=fname+"_"+anchname+".html";
        }
		
	    var BackupStatus = document.getElementById('BackupStatus');

        if(BackupStatus.innerHTML == '""')
        {
            BackupStatus.innerHTML = "";
        }
    }
    
    function isvalidip (addr)
    {
        var sub_addr;
        var net_id;
        var host_id;
		
        if (addr.search(/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/) == -1)
            return false;
        sub_addr = addr.split(/\./);
        if (sub_addr[0] > 0xff || sub_addr[1] > 0xff || sub_addr[2] > 0xff || sub_addr[3] > 0xff)
           return false;        
	    if(sub_addr[0] == 0 && sub_addr[1] == 0 && sub_addr[2] == 0 && sub_addr[3] == 0)
	       return false;
        if(sub_addr[0] < 128) /* A class */
        {
            if(sub_addr[0] == 0 || sub_addr[0] == 127)
                return false;
            host_id = sub_addr[1] * 0x10000 + sub_addr[2] * 0x100 + sub_addr[3] * 0x1;
            if(host_id == 0 || host_id == 0xffffff)
                return false;
        }
        else if(sub_addr[0] < 192) /* B class */
        {
            host_id = sub_addr[2] * 0x100 + sub_addr[3] * 0x1; 
            if(host_id == 0 || host_id == 0xffff)
                return false;           
        }
        else if(sub_addr[0] < 224) /* C class */
        {
            host_id = sub_addr[3] * 0x1;
            if(host_id == 0 || host_id == 0xff)
               return false;             
        }
        else  /* Limit broadcast, Multicast net */
        {
            return false;                                         
        }  
        return true;
    }

    function setaction(mode)
    {
	    /*check Tftp IP*/
        var IP0 = document.BackupSettings.TftpIP0;
        var IP1 = document.BackupSettings.TftpIP1;
        var IP2 = document.BackupSettings.TftpIP2;
        var IP3 = document.BackupSettings.TftpIP3;
		var FullIp = IP0.value + "." + IP1.value + "." + IP2.value + "." + IP3.value;
		
		if(!isvalidip(FullIp))
        {
            alert("TFTP IP is invalid!");
            return false;
        }
		document.BackupSettings.HidFullIp.value = FullIp;
	
	    /*check FileName*/
	    var FileName = document.BackupSettings.DownloadFilename.value;
		if(FileName.value == "")
        {
            alert("Invalid filename!");
            return false;
        }
        document.BackupSettings.HidFileName.value = FileName;

		document.BackupSettings.HidMode.value = mode;
        
		document.getElementById('BackupStatus').innerHTML = "Please wait..."
	            
		return true;
    }

	function ProcessError(sError)
    {
        var sErrorHTML = "";
        if (sError == "" || sError==undefined)
        {
            sErrorHTML = "";
        }
        else
        {
            sErrorHTML = '<tr><td class="error">' + sError + '</td></tr>';
        }
        return sErrorHTML;
    }
    </script>
</head>

<body onload='loadhelp("help","hidden_BackupSettings")'>
    <form name="BackupSettings" action="backup_setting.cgi" method="POST" >
        <input type="hidden" name="pagename" value="hidden_BackupSettings.asp">
		<input type="hidden" name="HidMode" value="">
		<input type="hidden" name="HidFullIp" value="">
		<input type="hidden" name="HidFileName" value="">
        <h1>Backup Settings</h1>
		<table width="100%">
		<script language="JavaScript">document.writeln(ProcessError(""));</script>
            <tr><td><hr size="2" color="#0099cc"></td></tr>
            <tr><td>
                <table width="100%">
                    <tr>
                        <td align="left"><b>TFTP server IP address:</b></td>
                        <td>
                            <input type="text" name="TftpIP0" size="1" maxlength="3"  value=0><b>.</b>
                            <input type="text" name="TftpIP1" size="1" maxlength="3"  value=0><b>.</b>
                            <input type="text" name="TftpIP2" size="1" maxlength="3"  value=0><b>.</b>
                            <input type="text" name="TftpIP3" size="1" maxlength="3"  value=0>
                        </td>
                    </tr>
                    <tr>
                        <td><b>File Name:</b></td>
                        <td colspan=7 ><input type="text" name="DownloadFilename" size="28" maxlength="128" value=""></td>
                    </tr>
					<tr>
                        <td colspan="2" id="BackupStatus"><% manage_get("backup_status"); %></td>
                    </tr>
                </table>
            </td></tr> 
            <tr><td><hr size="2" color="#0099cc"></td></tr>
            <tr><td>
                <table align="center">
                    <tr>
                        <td><input type="Submit" name="Backup" value="Back Up" onclick= "return setaction('w')" ></td>
                        <td><input type="Submit" name="Restore" value="Restore" onclick= "return setaction('r')"></td>
                    </tr>
                </table>
            </td></tr>
        </table>
    </form>
</body>
</html>