/*
 * CGI Handle Functions
 *
 * Copyright 2003, Broadcom Corporation
 * All Rights Reserved.                
 *                                     
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Broadcom Corporation;   
 * the contents of this file may not be disclosed to third parties, copied
 * or duplicated in any form, in whole or in part, without the prior      
 * written permission of Broadcom Corporation.                            
 *
 * $Id: cgihandle.c,v 1.1.1.1 2010/06/30 06:49:33 eating Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>

#include "sys_types.h"

#include "httpd.h"
//#include "pacm_prov_db.h"
//#include "pacm_net_utilities.h"
#include "docsis_nvram_mngr.h"
#include "autoconf.h" /* #UnihanBU6#,Alisa_Gao, 20081105,Add for compiler control*/

void do_apply_cgi(char *url, FILE *stream);
static void do_apply_post (char *url, webs_t stream, int len, char *boundary);
#if 0
static int apply_passwd_cgi(webs_t wp, char_t *urlPrefix, char_t *webDir, int arg, char_t *url, char_t *path, char_t *query);
static int apply_lockrf_cgi(webs_t wp, char_t *urlPrefix, char_t *webDir, int arg, char_t *url, char_t *path, char_t *query);
static int apply_eventlog_cgi(webs_t wp, char_t *urlPrefix, char_t *webDir, int arg, char_t *url, char_t *path, char_t *query);
#endif
extern int SIGNAL_Handle(int eid, webs_t wp, int argc, char_t **argv);
extern int SYSTEM_Handle(int eid, webs_t wp, int argc, char_t **argv);
extern int INTERFACE_Handle(int eid, webs_t wp, int argc, char_t **argv);
extern int PROVISION_Handle(int eid, webs_t wp, int argc, char_t **argv);
extern int MTA_Handle(int eid, webs_t wp, int argc, char_t **argv);
extern int CM_Handle(int eid, webs_t wp, int argc, char_t **argv);
extern int EVENTLOG_Handle(int eid, webs_t wp, int argc, char_t **argv);
extern int QOS_Handle(int eid, webs_t wp, int argc, char_t **argv);
extern  int TECH_Handle(int eid, webs_t wp, int argc, char_t **argv);
 /* #UnihanBU6#,Rainy_yuan, 20081114,add cgi handler for GR909 webpage  */
extern int LINETEST_Handle(int eid, webs_t wp, int argc, char_t **argv);
 /* #UnihanBU6#,Alisa_Gao, 20081104,Complier control for battery UI  */
#if(CONFIG_FOR_NETGEAR_BATTERY) 
extern int BATTERY_Handle(int eid, webs_t wp, int argc, char_t **argv);
#endif 
/* #UnihanBU6#,Chenwin_Qiu, 20080220,add cgi handler for Hidden page  */
extern int MANAGE_Handle(int eid, webs_t wp, int argc, char_t **argv);


/* #UnihanBU6#,Chenwin, 20080220,implement CGI for hiddenindex pages Start*/
extern int apply_techsupport_cgi(webs_t wp, char_t *urlPrefix, char_t *webDir, int arg,char_t *url, char_t *path, char_t *query);
extern int apply_adventrance_cgi(webs_t wp, char_t *urlPrefix, char_t *webDir, int arg,char_t *url, char_t *path, char_t *query);
extern int apply_management_cgi(webs_t wp, char_t * urlPrefix, char_t * webDir, int arg, char_t * url, char_t * path, char_t * query);
extern int apply_linetest_cgi(webs_t wp, char_t * urlPrefix, char_t * webDir, int arg, char_t * url, char_t * path, char_t * query);
extern int apply_dsfrequency_cgi(webs_t wp, char_t * urlPrefix, char_t * webDir, int arg, char_t * url, char_t * path, char_t * query);
extern int apply_customscanplan_cgi(webs_t wp, char_t * urlPrefix, char_t * webDir, int arg, char_t * url, char_t * path, char_t * query);
extern int apply_changeplanlkf_cgi(webs_t wp, char_t * urlPrefix, char_t * webDir, int arg, char_t * url, char_t * path, char_t * query);
extern int apply_backupsetting_cgi(webs_t wp, char_t * urlPrefix, char_t * webDir, int arg, char_t * url, char_t * path, char_t * query);
/* #UnihanBU6#,Chenwin, 20080224,End*/
/* #UnihanBU6,Ailsa_Cai,20090224,add CGI for hidden Pages ,Start*/
extern int apply_gous_cgi(webs_t wp, char_t * urlPrefix, char_t * webDir, int arg, char_t * url, char_t * path, char_t * query);
extern int apply_password_cgi(webs_t wp, char_t * urlPrefix, char_t * webDir, int arg, char_t * url, char_t * path, char_t * query);
extern int apply_telnet_cgi(webs_t wp, char_t * urlPrefix, char_t * webDir, int arg, char_t * url, char_t * path, char_t * query);
extern int apply_firmwareupgrade_cgi(webs_t wp, char_t * urlPrefix, char_t * webDir, int arg, char_t * url, char_t * path, char_t * query);
extern int apply_vsif_cgi(webs_t wp, char_t * urlPrefix, char_t * webDir, int arg, char_t * url, char_t * path, char_t * query);
/* #UnihanBU6,Ailsa_Cai,End*/

int do_auth (char *userid, char *passwd, char *realm);
 /* #UnihanBU6#,Alisa_Gao, 20081104,different Level has different content UI page  */
void do_content_file(char *path,webs_t stream);
	
struct mime_handler mime_handlers[] = {
    { "**.asp", "text/html", NULL, NULL, do_ej, do_auth },
    { "**.cgi*", "text/html", NULL, do_apply_post, do_apply_cgi, do_auth },
    {"contents.html","text/html",NULL,NULL,do_content_file,do_auth},	/* #UnihanBU6#,Alisa_Gao, 20081104,different Level has different content UI page  */
    { "**.htm", "text/html", NULL, NULL, do_file, do_auth },	/*#UnihanBU6#,Alisa_Gao, addend End*/
    { "**.html", "text/html", NULL, NULL, do_file, do_auth },
    { "**.gif", "image/gif", NULL, NULL, do_file, NULL },
    { "**.jpg", "image/jpeg", NULL, NULL, do_file, NULL },
    { "**.jpeg", "image/gif", NULL, NULL, do_file, NULL },
    { "**.png", "image/png", NULL, NULL, do_file, NULL },
    { "**.css", "text/css", NULL, NULL, do_file, NULL },
    { "**.au", "audio/basic", NULL, NULL, do_file, NULL },
    { "**.wav", "audio/wav", NULL, NULL, do_file, NULL },
    { "**.avi", "video/x-msvideo", NULL, NULL, do_file, NULL },
    { "**.mov", "video/quicktime", NULL, NULL, do_file, NULL },
    { "**.mpeg", "video/mpeg", NULL, NULL, do_file, NULL },
    { "**.vrml", "model/vrml", NULL, NULL, do_file, NULL },
    { "**.midi", "audio/midi", NULL, NULL, do_file, NULL },
    { "**.mp3", "audio/mpeg", NULL, NULL, do_file, NULL },
    { "**.pac", "application/x-ns-proxy-autoconfig", NULL, NULL, do_file, NULL },
    { NULL, NULL, NULL, NULL, NULL, NULL }
};

struct ej_handler ej_handlers[] = {
    { "signal_get", SIGNAL_Handle },
    { "system_get", SYSTEM_Handle },
    { "iftable_show", INTERFACE_Handle },
    { "provision_get", PROVISION_Handle },
    { "mta_get", MTA_Handle },
    { "cm_get", CM_Handle },
    { "event_show", EVENTLOG_Handle },
    { "qos_get", QOS_Handle },
    {"tech_get",TECH_Handle},
     /* #UnihanBU6#,Alisa_Gao, 20081106,Add for test line UI,Start*/
    {"linetest_get",LINETEST_Handle},
    /* #UnihanBU6#,Alisa_Gao, End*/
    /* #UnihanBU6#,Alisa_Gao, 20081105,Add for battery UI,Start*/
    #if (CONFIG_FOR_NETGEAR_BATTERY)	 
    {"battery_get", BATTERY_Handle},
    #endif 
    /* #UnihanBU6#,Alisa_Gao, 20081105,End*/
    /* #UnihanBU6#,Chenwin_Qiu, 20080220,Add for hidindex UI,Start*/
    {"manage_get",MANAGE_Handle},
    /* #UnihanBU6#,Chenwin_Qiu, 20080220,End*/
    { NULL, NULL }
};

/* #UnihanBU6#,Chenwin, 20090220,add CGI method for httpd server */
struct cgi_apply_handler cgi_apply_handlers[]={
    { "techsupport.cgi",apply_techsupport_cgi},
    { "adventrance.cgi",apply_adventrance_cgi},
    { "management.cgi",apply_management_cgi},
    { "linetest.cgi",apply_linetest_cgi},
    { "ds_frequency.cgi",apply_dsfrequency_cgi},
    { "custom_scanplan.cgi",apply_customscanplan_cgi},
    { "change_scanplanlkf.cgi",apply_changeplanlkf_cgi},
    { "backup_setting.cgi",apply_backupsetting_cgi},
/* #UnihanBU6,Ailsa_Cai,20090224,add CGI for hidden Pages ,Start*/
    {"goUs.cgi",apply_gous_cgi},
    {"setPassword.cgi",apply_password_cgi},
    {"setTelnet.cgi",apply_telnet_cgi},
    {"firmwareUpgrade.cgi",apply_firmwareupgrade_cgi}, 
    {"setVsif.cgi",apply_vsif_cgi},   
/* #UnihanBU6,Ailsa_Cai,end*/
    { NULL,NULL}
};
/* #UnihanBU6#,Chenwin, 20090224,End */

 /* #UnihanBU6#,Alisa_Gao, 20080715,implement POST method for httpd server  */
char post_buf[10000] = { 0 };
extern int post;
static void do_apply_post (char *url, webs_t stream, int len, char *boundary)
{	
    int count;
    if(post == 1)
    {
        if (len > sizeof (post_buf) - 1)
	 {
            fprintf(stderr,"%s","The POST data exceed length limit!\n");
            return;
	 }
	 if(!(count = wfread (post_buf,1, len,stream)))
	     return;
	     post_buf[count] = '\0';
	     init_cgi (post_buf);
    }
}

void 
do_apply_cgi(char * url, FILE * stream)
{
    char *path, *query;
    struct cgi_apply_handler *handler ;
    /* Parse path */
    query = url;
    path = strsep(&query, "?") ? : url;
    /*when method is GET*/
    if( post == 0)
    {
        init_cgi(query);
    }
#if 0  //need to implement
    if (strcmp(path, "RgSecurity.cgi") == 0 )
    {
        apply_passwd_cgi(stream, NULL, NULL, 0, url, path, query);
    }
    else if (strcmp(path, "RgLockRF.cgi") == 0 )
    {
        apply_lockrf_cgi(stream, NULL, NULL, 0, url, path, query);
    }	
    else if (strcmp(path, "RgEventLog.cgi") == 0 )
    {
        apply_eventlog_cgi(stream, NULL, NULL, 0, url, path, query);
    }	
    else
    {
        apply_cgi(stream, NULL, NULL, 0, url, path, query);
    }
#else
    /* #UnihanBU6#,Chenwin_Qiu, 20090220,modify method to realize it*/
    for(handler=&cgi_apply_handlers[0];handler->pattern;handler++)     
    {       
        if(strncmp(handler->pattern,path,strlen(handler->pattern)) == 0)        
        {            
            handler->output(stream,NULL,NULL,0,url,path,query);
            break;         
	 }     
    }
#endif
    /* Reset CGI */
    init_cgi(NULL);
}

#if 0 //need to implement
static int
apply_lockrf_cgi(webs_t wp, char_t *urlPrefix, char_t *webDir, int arg, 
	  char_t *url, char_t *path, char_t *query)
{
	char *gotofreq;

	gotofreq = websGetVar(wp, "GotoFreq", "");
	/* Apply values */
	lockrf_set(0, wp, atoi(gotofreq));
	do_ej("RgLockFrequency.asp", wp);
}

static int
apply_passwd_cgi(webs_t wp, char_t *urlPrefix, char_t *webDir, int arg, 
	  char_t *url, char_t *path, char_t *query)
{
	//int action = NOTHING;
	char *passwd, *repasswd;

	passwd = websGetVar(wp, "NetgearPassword", "");
	repasswd = websGetVar(wp, "NetgearPasswordReEnter", "");

	/* Apply values */
	security_set(0, wp, passwd);
	do_ej("RgSecurity.asp", wp);
}

static int
apply_eventlog_cgi(webs_t wp, char_t *urlPrefix, char_t *webDir, int arg, 
	  char_t *url, char_t *path, char_t *query)
{
	char *cleareventlog;

	cleareventlog = websGetVar(wp, "SnmpClearEventLog", "");
	/* Apply values */
	clearlog_set(0, wp, atoi(cleareventlog));
	do_ej("RgEventLog.asp", wp);
}
#endif

int
do_auth (char *userid, char *passwd, char *realm)
{
  auth_get(userid, passwd, realm);
  return 0;
}


