/*
 * CGI helper functions
 *
 * Copyright 2003, Broadcom Corporation
 * All Rights Reserved.                
 *                                     
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Broadcom Corporation;   
 * the contents of this file may not be disclosed to third parties, copied
 * or duplicated in any form, in whole or in part, without the prior      
 * written permission of Broadcom Corporation.                            
 *
 * $Id: interface.c,v 1.1.1.1 2010/06/30 06:49:33 eating Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "httpd.h"
#include "vendor_common_utils.h"
#include "chdb_main.h"

int INTERFACE_Handle(int eid, webs_t wp, int argc, char_t **argv);
int INTERFACE_TableShow(webs_t wp,char_t *name);

struct cgi_handler INTERFACE_handlers[]=
{
    {"basic",INTERFACE_TableShow},
    {"test",INTERFACE_TableShow},  /* #UnihanBU6,Ailsa_Cai,20090313,Add for hid_forTest.asp */
    {"advanced",INTERFACE_TableShow},
    {NULL,NULL},
};

int INTERFACE_Handle(int eid, webs_t wp, int argc, char_t **argv)
{
    char_t*name;
    struct cgi_handler *handler;
    
    if(CHDB_Main_RetrieveAccess() == NOK)
    {
        websWrite(wp,"%s","unknow");
        return -1;
    }
    
    if(ejArgs(argc,argv,"%s",&name)<1)
    {
        websError(wp,400,"Insufficient args\n");
        return -1;
    }
    
    for(handler=&INTERFACE_handlers[0];handler->pattern;handler++)
    {
        if(strncmp(handler->pattern,name,strlen(handler->pattern))==0)
            handler->output(wp,name);
    }
    return 0;
}

int INTERFACE_TableShow(webs_t wp,char_t *name)
{
    IfDb_Entry_t *data = NULL;
    int idx;
    int flag=0; //basic=0  advanced=1  test=2
    int addrIdx;
    char buffer[32];
    struct in_addr buff;
    /* #UnihanBU6, Chenwin_Qiu, 200904007, Fix Interface Name displaying format. */
    char tmpname[IF_MAXSIZE_NAME];
    memset(buffer,0,sizeof(buffer));
    
    if ( strcmp(name,"advanced") == 0)
        flag=1;

    /* #UnihanBU6,Ailsa_Cai,20090313,Add for hid_forTest.asp */
    if ( strcmp(name,"test") == 0)
        flag=2;

    for ( idx = 0; idx < IF_INDEXES_MAX_NUM; idx++ )
    {
        data = Common_Utils_GetIfTableByIndex(idx) ;
        if ((data != NULL))
        {
        /* #UnihanBU6,Ailsa_Cai,20090313,Add for hid_forTest.asp */ 
            if (flag == 2)
            {
                //Interface name
                websWrite(wp,"%s:%s :&nbsp;&nbsp;",(*data).pIfDescr2Index->ifName,(*data).pIfDescr2Index->ifDescr );
                
                // mac address
                if ((*data).ifPhysAddress_len == 0)
                websWrite(wp,"------<br>"); 
                for (addrIdx = 0; addrIdx < (*data).ifPhysAddress_len; addrIdx++)
                {
                    if ((*data).ifPhysAddress_len == 0)
                        websWrite(wp,"------");	

                    websWrite(wp,"%2.2x",(*data).ifPhysAddress.hw[addrIdx]); 		

                    if (addrIdx+1 < (*data).ifPhysAddress_len)
                        websWrite(wp,":");	
                    else
                        websWrite(wp,"<br>");	
                }
            }
            else
            {        
            //Interface name
            /* #UnihanBU6,Alisa_Gao,20090324,Filter the dsch/usch,Customer require to delete*/ 
                if((strncmp((*data).pIfDescr2Index->ifName,"dsch",4) == 0)||
                    strncmp((*data).pIfDescr2Index->ifName,"usch",4)==0)
                {
                    continue;
                }
#if (CONFIG_FOR_NETGEAR_TDC)
            /* #UnihanBU6,Rainy_yuan,20090717,Filter the usb0 for TDC*/ 
                if(strncmp((*data).pIfDescr2Index->ifName,"usb0",4) == 0)
                {
                    continue;
                }
#endif
                /* #UnihanBU6, Chenwin_Qiu, 200904007, Fix Interface Name displaying format, Start */
                if(strncmp((*data).pIfDescr2Index->ifName,"eth0",4) == 0)
                {
                    memcpy(tmpname,"Ethernet",sizeof("Ethernet"));
                }
                else if (strncmp((*data).pIfDescr2Index->ifName,"cni0",4) == 0)
                {
                    memcpy(tmpname,"Cable Modem",sizeof("Cable Modem"));
                }
                else if (strncmp((*data).pIfDescr2Index->ifName,"usb0",4) == 0)
                {
                    memcpy(tmpname,"USB",sizeof("USB"));
                }
                else if (strncmp((*data).pIfDescr2Index->ifName,"mta0",4) == 0)
                {
                    memcpy(tmpname,"MTA",sizeof("MTA"));
                }
                else
                    memcpy(tmpname,(*data).pIfDescr2Index->ifName,sizeof((*data).pIfDescr2Index->ifName));
		
                websWrite(wp,"<tr><td>%s</td>",tmpname);
		
                //delete Description about device.		
                //websWrite(wp,"<tr><td>%s:%s</td>",tmpname,(*data).pIfDescr2Index->ifDescr );
            /* #UnihanBU6, Chenwin_Qiu, 200904007, Fix Interface Name displaying format, End */
                //provisioned
                switch((*data).ifAdminStatus)
                {
                    case 1: // up
                    sprintf(buffer,"Enabled");
                    break;
                
                    case 2: // down
                    default:
                    sprintf(buffer,"Disabled");
                    break;
                
                    case 3: // testing
                    sprintf(buffer,"Testing");
                    break;
                 }
                 websWrite(wp,"<TD>%s</TD>",buffer);

                 //state
                 switch((*data).ifOperStatus)
                 {
                     case 1: // up
                     sprintf(buffer,"Up");
                     break;
                 
                     case 2: // down
                     default:
                     sprintf(buffer,"Down");
                  	/* #UnihanBU6#, Rainy_yuan, 20090806, TT1658, if interface status is down, speed show 0 */
			(*data).ifSpeed = 0;
                     break;
                     
                     case 3: // testing
                     sprintf(buffer,"Testing");
                     break;
                     
                     case 4: // unknown
                     sprintf(buffer,"Unknown");
                     break;
                     
                     case 5: // dorman
                     sprintf(buffer,"Dormant");
                     break;
                     
                     case 6: // not present
                     sprintf(buffer,"Not present>");
                     break;
                     
                     case 7: // lowerlayerdown
                     sprintf(buffer,"Lower layer down");
                     break;
                 }
                 websWrite(wp,"<td>%s</td>",buffer);

                  // speed
                  /* #UnihanBU6#, Chenwin_Qiu, 20090407, Fix display speed format */
                  websWrite(wp,"<td>%d</td>",(*data).ifSpeed/1000000);
                  
                  // mac address
                  if ((*data).ifPhysAddress_len == 0)
                  websWrite(wp,"<td>------</td>"); 
                  for (addrIdx = 0; addrIdx < (*data).ifPhysAddress_len; addrIdx++)
                  {
                      if (addrIdx == 0)
                          websWrite(wp,"<td>");	
                      
                      if ((*data).ifPhysAddress_len == 0)
                          websWrite(wp,"------");	
                      
                      websWrite(wp,"%2.2x",(*data).ifPhysAddress.hw[addrIdx]); 		

                      if (addrIdx+1 < (*data).ifPhysAddress_len)
                          websWrite(wp,":");	
                      else
                          websWrite(wp,"</td>");	
                  }

                 // ipaddress and netmask  only for advanced page
                 if (flag ==1)
                 {
                      buff.s_addr = (*data).ifAddr;
                      websWrite(wp,"<td>%s</td>",inet_ntoa(buff));	
                      buff.s_addr = (*data).netMask;
                      websWrite(wp,"<td>%s</td>",inet_ntoa(buff));	
                 }				
		}
	   }	  
	}
	return 0;
}

