/*
 * CGI helper functions
 *
 * Copyright 2003, Broadcom Corporation
 * All Rights Reserved.                
 *                                     
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Broadcom Corporation;   
 * the contents of this file may not be disclosed to third parties, copied
 * or duplicated in any form, in whole or in part, without the prior      
 * written permission of Broadcom Corporation.
 *
 * $Id: linetest.c,v 1.1.1.1 2010/06/30 06:49:33 eating Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "httpd.h" 
#include "voim.h"
/* #UnihanBU6#, Chenwin_Qiu, 20090401, implement record last test time. */
#include "vendornvm_docsis.h"
#include "system_shmdb_util.h"

#define MAX_DIAG_TEST_VALUE_LENGTH 256
#define MAX_DIAG_TEST_VALUE_ITEMLEN 64
#define TEST_LINE1 0
#define TEST_LINE2 1
#define TEST_BOTH 2
/* #UnihanBU6#, Chenwin_Qiu, 20090401, implement record last test time. */
#define MIDNIGHT_JAN_01_2000 (60L*60L*24L*7L*52L*30L+60L*60L*24L*37L)

extern int get_code_index(char *name, char *prex); 
int LINETEST_Handle(int eid, webs_t wp, int argc, char_t **argv);
int LINETEST_get_startTipToGroundShortDetection(webs_t wp,char_t *name);
int LINETEST_get_startRingToGroundShortDetection(webs_t wp,char_t *name);
int LINETEST_get_startTipToRingShortDetection(webs_t wp,char_t *name);
int LINETEST_get_startRingerEquivalenceNetwork(webs_t wp,char_t *name);
int LINETEST_get_startHazardousPotentialsTest(webs_t wp,char_t *name);
int LINETEST_get_startForeignElectromotiveForceTest(webs_t wp,char_t *name);
int LINETEST_get_startReceiverOffhook(webs_t wp,char_t *name);
int LINETEST_get_testStatus(webs_t wp,char_t *name);
STATUS LINETEST_set_LineTestReset(webs_t wp, char_t *name);
/* #UnihanBU6#, Chenwin_Qiu, 20090401, implement record last test time. */
int LINETEST_get_lastTestTime(webs_t wp,char_t *name);
int  apply_linetest_cgi(webs_t wp, char_t *urlPrefix, char_t *webDir, int arg,char_t *url, char_t *path, char_t *query);

typedef enum
{
    startTipToGroundShortDetection = 0,
    startRingToGroundShortDetection,
    startTipToRingShortDetection,
    startRingerEquivalenceNetwork,
    startHazardousPotentialsTest,
    startForeignElectromotiveForceTest,
    startReceiverOffhook,
    TESTITME_LEN   
}GR909_TEST_ID;


int linetest = 0;
UINT16 testid=0;
UINT32 test_valid1= 0;
UINT32 test_valid2=0;

char  test_value1[MAX_DIAG_TEST_VALUE_LENGTH];
char test_value2[MAX_DIAG_TEST_VALUE_LENGTH];
char line1_item_value[TESTITME_LEN][MAX_DIAG_TEST_VALUE_ITEMLEN];
char line2_item_value[TESTITME_LEN][MAX_DIAG_TEST_VALUE_ITEMLEN];

/* #UnihanBU6# , Ailsa_cai , 20090401, fixed If line1 do the testing, line2 record not be erased ,start*/
UINT16 testid1=0;
UINT16 testid2=0;
UINT32 test_result1=0;
UINT32 test_result2=0;
/* #UnihanBU6# , Ailsa_cai , 20090401, End */

struct cgi_handler LINETEST_handlers[]=
{
    {"startTipToGroundShortDetection0",LINETEST_get_startTipToGroundShortDetection},
    {"startTipToGroundShortDetection1",LINETEST_get_startTipToGroundShortDetection},

    {"startRingToGroundShortDetection0",LINETEST_get_startRingToGroundShortDetection},
    {"startRingToGroundShortDetection1",LINETEST_get_startRingToGroundShortDetection},

    {"startTipToRingShortDetection0",LINETEST_get_startTipToRingShortDetection},
    {"startTipToRingShortDetection1",LINETEST_get_startTipToRingShortDetection},

    {"startRingerEquivalenceNetwork0",LINETEST_get_startRingerEquivalenceNetwork},
    {"startRingerEquivalenceNetwork1",LINETEST_get_startRingerEquivalenceNetwork},

    {"startHazardousPotentialsTest0",LINETEST_get_startHazardousPotentialsTest},
    {"startHazardousPotentialsTest1",LINETEST_get_startHazardousPotentialsTest},

    {"startForeignElectromotiveForceTest0",LINETEST_get_startForeignElectromotiveForceTest},
    {"startForeignElectromotiveForceTest1",LINETEST_get_startForeignElectromotiveForceTest},

    {"startReceiverOffhook0",LINETEST_get_startReceiverOffhook},
    {"startReceiverOffhook1",LINETEST_get_startReceiverOffhook},

    /* #UnihanBU6#, Chenwin_Qiu, 20090401, implement record last test time. */
    /* #UnihanBU6#, Chenwin_Qiu, 2009/04/10, record test time line 1 and line2 apart. */
    {"startRecordLastTestTime0",LINETEST_get_lastTestTime},
    {"startRecordLastTestTime1",LINETEST_get_lastTestTime},	

    {NULL,NULL}
};


int LINETEST_Handle(int eid, webs_t wp, int argc, char_t **argv)
{
    char_t*name;
    int i=0;
    int offset=0x00;
    UINT32 v_len = sizeof(test_value1);
    struct cgi_handler *handler;
    
    if( VOIM_init( TI_PACM_MODULE_CTX( TI_PACM_MODULE_VOIM ), 1 ) != OK )
    {
        perror("VOIM_init");
        return -1;
    }
    /* #UnihanBU6#, Chenwin_Qiu, 20090401, implement record last test time. Start */
/* #UnihanBU6#, Eating Chen, 2009/12/02, System_ShmDb_RetrieveAccess() function 
 * shall be called once in each process/task 
 */
#if 0
    if(System_ShmDb_RetrieveAccess() == NOK)
    {
        websWrite(wp,"%s","unknow");
        return -1;
    }
#endif
    /* #UnihanBU6#, Chenwin_Qiu, 20090401, implement record last test time. End */
    if(ejArgs(argc,argv,"%s",&name)<1)
    {
        websError(wp,400,"Insufficient args\n");
        return -1;
    }
#if 0 /* #UnihanBU6# , Ailsa_cai , 20090401, fixed If line1 do the testing, line2 record not be erased */
    for( i=0; i<TESTITME_LEN; i++)
    {
        strcpy(line1_item_value[i],"In progress");
        strcpy(line2_item_value[i],"In progress");
    }
#endif
	
    if((linetest == TEST_LINE1)||(linetest == TEST_BOTH))
    {
    /* #UnihanBU6# , Ailsa_cai , 20090401, fixed If line1 do the testing, line2 record not be erased ,start*/
        for( i=0; i<TESTITME_LEN; i++)
        {
            strcpy(line1_item_value[i],"In progress");			
        }
    /* #UnihanBU6# , Ailsa_cai , 20090401, End */	
        memset(test_value1,0,MAX_DIAG_TEST_VALUE_LENGTH);
        if ((VOIM_get_config_param( NMM_XGCP_GR909_TEST_VALUE, TEST_LINE1, NULL, &v_len, test_value1) == OK) &&
            (VOIM_get_config_param( NMM_XGCP_GR909_TEST_VALID, TEST_LINE1, &test_valid1, 0, NULL ) == OK))
        {
/* #UnihanBU6# , Jimmy, 20080410, fix the ReceiverOffhook show test result issue */
            if (test_valid1 != 0)
            {
                char *ptr1=test_value1;
                for( i=0; i<TESTITME_LEN; i++)
                {
                    offset=0x01<<i;
/* #UnihanBU6# , Jimmy, 20080410, fix the ReceiverOffhook show test result issue */
		      if (i == startReceiverOffhook)
		      {
                        if (VOIM_get_config_param( NMM_XGCP_GR909_TEST_RESULT, TEST_LINE1, &test_result1, 0, NULL ) != OK)                  
                        {
                            printf("\n Can't get test result!\n");
                            return 0;
                        }
                        if (test_valid1 & offset)
                        {
                            if (test_result1 & offset)
                            {
                                strcpy(line1_item_value[i], "onhook");
                            }
                            else
                            {
                                strcpy(line1_item_value[i], "offhook");
                            }
                        }
                    }
                    else
                    {
                        if(test_valid1 & offset)
                        {
                            strcpy(line1_item_value[i],strsep(&ptr1,"]")+1);
                        }
                    }
                }
            }
        }
    }

    if((linetest == TEST_LINE2)||(linetest == TEST_BOTH))
    {
        /* #UnihanBU6# , Ailsa_cai , 20090401, fixed If line1 do the testing, line2 record not be erased ,start*/
        for( i=0; i<TESTITME_LEN; i++)
        {
            strcpy(line2_item_value[i],"In progress");			
        }	
        /* #UnihanBU6# , Ailsa_cai , 20090401, End*/	
        memset(test_value2, 0, MAX_DIAG_TEST_VALUE_LENGTH);
        if ((VOIM_get_config_param( NMM_XGCP_GR909_TEST_VALUE, TEST_LINE2, NULL, &v_len, test_value2) == OK) &&
            (VOIM_get_config_param( NMM_XGCP_GR909_TEST_VALID, TEST_LINE2, &test_valid2, 0, NULL ) == OK))
        {
/* #UnihanBU6# , Jimmy, 20080410, fix the ReceiverOffhook show test result issue */
            if (test_valid2 != 0)
            {
                char *ptr2=test_value2;
                for( i=0; i<TESTITME_LEN; i++)
                {
                    offset=0x01<<i;
/* #UnihanBU6# , Jimmy, 20080410, fix the ReceiverOffhook show test result issue */
		      if (i == startReceiverOffhook)
		      {
                        if (VOIM_get_config_param( NMM_XGCP_GR909_TEST_RESULT, TEST_LINE2, &test_result2, 0, NULL ) != OK)                  
                        {
                            printf("\n Can't get test result!\n");
                            return 0;
                        }
                        if (test_valid2 & offset)
                        {
                            if (test_result2 & offset)
                            {
                                strcpy(line2_item_value[i], "onhook");
                            }
                            else
                            {
                                strcpy(line2_item_value[i], "offhook");
                            }
                        }
		    }
                    else
                    {
                        if(test_valid2 & offset)
                        {
                            strcpy(line2_item_value[i],strsep(&ptr2,"]")+1);
                        }
                    }
                }	
            }
        }
    }

    for(handler=&LINETEST_handlers[0];handler->pattern;handler++)
    {
        if(strncmp(handler->pattern,name,strlen(handler->pattern))==0)
            handler->output(wp,name);
    }
    return 0;
}


int  apply_linetest_cgi(webs_t wp, char_t *urlPrefix, char_t *webDir, int arg,char_t *url, char_t *path, char_t *query)
{	
    int type = atoi(websGetVar(wp, "buttontype", ""));
    testid = atoi(websGetVar(wp,"testid", ""));
    linetest=atoi(websGetVar(wp,"linetest",""));
    int linereset = atoi(websGetVar(wp,"linereset",""));
	
    /* #UnihanBU6#, Chenwin_Qiu, 20090401, implement record last test time. Start */
    time_t curtime;
/* #UnihanBU6#, Eating Chen, 2009/12/09, System_ShmDb_RetrieveAccess() function 
 * shall be called once in each process/task 
 */
#if 0
    if(System_ShmDb_RetrieveAccess() == NOK)
    {
        websWrite(wp,"%s","unknow");
        return -1;
    }
#endif
    if(VendorNvm_Common_RetrieveAccess() == NOK)
    {
        websWrite(wp,"%s","unknow");
        return -1;
    }
    /* #UnihanBU6#, Chenwin_Qiu, 20090401, implement record last test time. End */
    
    switch(type)
    {
        case 0:/*start test*/
            if (linetest == TEST_BOTH)
            {
                /* #UnihanBU6# , Ailsa_cai , 20090401, fixed If line1 do the testing, line2 record not be erased ,start*/
                testid1 = testid;
                testid2 = testid;
                /* #UnihanBU6# , Ailsa_cai , 20090401, End*/
/* #UnihanBU6# shadow 2009/03/04 GR909 Test Status, show testing when GR909 is under testing 
 *  Common_Utils_GR909TestStart will create a thread to polling the GR909 test status and terminal 
 *  the thread when test finish. change the status from testing to orginal status when test finish.
 */
#if 0
                if(( VOIM_set_config_param( NMM_XGCP_SET_GR909_TEST_START, TEST_LINE1, testid, 0, NULL , 0 ) != OK) ||
                    ( VOIM_set_config_param( NMM_XGCP_SET_GR909_TEST_START, TEST_LINE2, testid, 0, NULL , 0 ) != OK))		
#else
                if (( Common_Utils_GR909TestStart(TEST_LINE1, testid )  != OK) ||
                    ( Common_Utils_GR909TestStart(TEST_LINE2, testid ) != OK))
#endif
                {
                    printf("\n can't set test start\n");
                    return 0;
                }
            }
            else
            {
                /* #UnihanBU6# , Ailsa_cai , 20090401, fixed If line1 do the testing, line2 record not be erased ,start*/
                if(linetest == 0)
                {
                    testid1 = testid;
                }
                if(linetest == 1)
                {
                    testid2 = testid;
                }
                 /* #UnihanBU6# , Ailsa_cai , End*/				
#if 0       
                if( VOIM_set_config_param( NMM_XGCP_SET_GR909_TEST_START, linetest, testid, 0, NULL , 0 ) != OK) 
#else
                if ( Common_Utils_GR909TestStart(linetest, testid )  != OK)
#endif
                {
                    printf("\n can't set test start\n");
                    return 0;
                }
            }
            /* #UnihanBU6#, Chenwin_Qiu, 20090401, implement record last test time. Start */
            time(&curtime);
            /* #UnihanBU6#, Chenwin_Qiu, 2009/04/10, record test time line 1 and line2 apart. */
            if(System_ShmDb_SetLastTestTime(curtime,linetest,1) == NOK)
            {
                printf("Save to DB Fail\n");
            }
  			
            if(VendorNvm_Common_SaveToNvram() == NOK)
            {
                printf("Save To Nvram Fail\n");
            }
            /* #UnihanBU6#, Chenwin_Qiu, 20090401, implement record last test time. End */			
            break;
        case 1:/*line reset*/
            if (linereset == TEST_BOTH)
            {
                /* #UnihanBU6# , Ailsa_cai , 20090401, fixed If line1 do the testing, line2 record not be erased ,start*/
                testid1 = 0;
                testid2 = 0;
                /* #UnihanBU6# , Ailsa_cai , 20090401, End*/
                if(( VOIM_set_config_param( NMM_XGCP_LINE_RESET, TEST_LINE1, 1, 0, NULL , 0 ) != OK) ||
                    ( VOIM_set_config_param( NMM_XGCP_LINE_RESET, TEST_LINE2, 1, 0, NULL , 0 ) != OK))                  
                {
                    printf("\n can't reset the line1 and line2\n");
                    return 0;
                }
            }
            else
            {
                /* #UnihanBU6# , Ailsa_cai , 20090401, fixed If line1 do the testing, line2 record not be erased ,start*/
                if(linereset == TEST_LINE1)
                {
                    testid1 = 0;
                }

                if(linereset == TEST_LINE2)
                {
                    testid2 = 0;
                }
                /* #UnihanBU6# , Ailsa_cai , 20090401, End*/	
				
                if(VOIM_set_config_param( NMM_XGCP_LINE_RESET, linereset, 1, 0, NULL , 0 ) != OK) 
                {
                    printf("\n can't reset the line%d\n",linereset);
                    return 0;
                }
            }
            break;
        default:
            break;
    }
    do_ej("adv_linetest.asp",wp);
    return 0;
}

int LINETEST_get_startTipToGroundShortDetection(webs_t wp,char_t *name)
{
    int index=get_code_index(name,"startTipToGroundShortDetection");
    int offset=0x01 << startTipToGroundShortDetection;
    if(index == 0)
    {
#if 0    /* #UnihanBU6# , Ailsa_cai , 20090401, fixed If line1 do the testing, line2 record not be erased */
        if ((linetest == 0)&&(testid & offset))
#else
        if ((testid1 !=0 )&&(testid1 & offset))
#endif
        {
            websWrite(wp,"%s",line1_item_value[startTipToGroundShortDetection]);
        }
        else
        {
            websWrite(wp,"%s","not selected");
        }
    }
    else if(index == 1)
    { 
#if 0    /* #UnihanBU6# , Ailsa_cai , 20090401, fixed If line1 do the testing, line2 record not be erased */
        if ((linetest == 1)&&(testid & offset))
#else
        if ((testid2 !=0 )&&(testid2 & offset))
#endif
        {
            websWrite(wp,"%s",line2_item_value[startTipToGroundShortDetection]);
        }
        else
        {
            websWrite(wp,"%s","not selected");
        }
    }
    return 0;
}

int LINETEST_get_startRingToGroundShortDetection(webs_t wp,char_t *name)
{
    int index=get_code_index(name,"startRingToGroundShortDetection");
    int offset=0x01 << startRingToGroundShortDetection;
    if(index == 0)
    {
#if 0    /* #UnihanBU6# , Ailsa_cai , 20090401, fixed If line1 do the testing, line2 record not be erased */	
        if ((linetest == 0)&&(testid & offset))
#else
        if ((testid1 !=0 )&&(testid1 & offset))
#endif
        {
            websWrite(wp,"%s",line1_item_value[startRingToGroundShortDetection]);
        }
        else
        {
            websWrite(wp,"%s","not selected");
        }
    }
    else if(index == 1)
    {
#if 0    /* #UnihanBU6# , Ailsa_cai , 20090401, fixed If line1 do the testing, line2 record not be erased */
        if ((linetest == 1)&&(testid & offset))
#else
        if ((testid2 !=0 )&&(testid2 & offset))
#endif
        {
            websWrite(wp,"%s",line2_item_value[startRingToGroundShortDetection]);
        }
        else
        {
            websWrite(wp,"%s","not selected");
        }
    }
    return 0;
}

int LINETEST_get_startTipToRingShortDetection(webs_t wp,char_t *name)
{
    int index=get_code_index(name,"startTipToRingShortDetection");
    int offset=0x01 << startTipToRingShortDetection;
    if(index == 0)
    {
#if 0    /* #UnihanBU6# , Ailsa_cai , 20090401, fixed If line1 do the testing, line2 record not be erased */
        if ((linetest == 0)&&(testid & offset))
#else
        if ((testid1 !=0 )&&(testid1 & offset))
#endif
        {
            websWrite(wp,"%s",line1_item_value[startTipToRingShortDetection]);
        }
        else
        {
            websWrite(wp,"%s","not selected");
        }
    }
    else if(index == 1)
    {   
#if 0    /* #UnihanBU6# , Ailsa_cai , 20090401, fixed If line1 do the testing, line2 record not be erased */	
        if ((linetest == 1)&&(testid & offset))
#else
        if ((testid2 !=0 )&&(testid2 & offset))
#endif
        {
            websWrite(wp,"%s",line2_item_value[startTipToRingShortDetection]);
        }
        else
        {
            websWrite(wp,"%s","not selected");
        }
    }
    return 0;
}

int LINETEST_get_startRingerEquivalenceNetwork(webs_t wp,char_t *name)
{
    int index=get_code_index(name,"startRingerEquivalenceNetwork");
    int offset=0x01 << startRingerEquivalenceNetwork;
    if(index == 0)
    {
#if 0    /* #UnihanBU6# , Ailsa_cai , 20090401, fixed If line1 do the testing, line2 record not be erased */
        if ((linetest == 0)&&(testid & offset))
#else
        if ((testid1 !=0 )&&(testid1 & offset))
#endif
        {
            websWrite(wp,"%s",line1_item_value[startRingerEquivalenceNetwork]);
        }
        else
        {
            websWrite(wp,"%s","not selected");
        }
    }
    else if(index == 1)
    {   
#if 0    /* #UnihanBU6# , Ailsa_cai , 20090401, fixed If line1 do the testing, line2 record not be erased */	
        if ((linetest == 1)&&(testid & offset))
#else			
        if ((testid2 !=0 )&&(testid2 & offset))
#endif
        {
            websWrite(wp,"%s",line2_item_value[startRingerEquivalenceNetwork]);
        }
        else
        {
            websWrite(wp,"%s","not selected");
        }
    }
    return 0;
}

int LINETEST_get_startHazardousPotentialsTest(webs_t wp,char_t *name)
{
    int index=get_code_index(name,"startHazardousPotentialsTest");
    int offset=0x01 << startHazardousPotentialsTest;
    if(index == 0)
    {
#if 0    /* #UnihanBU6# , Ailsa_cai , 20090401, fixed If line1 do the testing, line2 record not be erased */
        if ((linetest == 0)&&(testid & offset))
#else
        if ((testid1 !=0 )&&(testid1 & offset))
#endif
        {
            websWrite(wp,"%s",line1_item_value[startHazardousPotentialsTest]);
        }
        else
        {
            websWrite(wp,"%s","not selected");
        }
    }
    else if(index == 1)
    {   
#if 0    /* #UnihanBU6# , Ailsa_cai , 20090401, fixed If line1 do the testing, line2 record not be erased */
        if ((linetest == 1)&&(testid & offset))
#else
        if ((testid2 !=0 )&&(testid2 & offset))
#endif
        {
            websWrite(wp,"%s",line2_item_value[startHazardousPotentialsTest]);
        }
        else
        {
            websWrite(wp,"%s","not selected");
        }
    }
    return 0;
}

int LINETEST_get_startForeignElectromotiveForceTest(webs_t wp,char_t *name)
{
    int index=get_code_index(name,"startForeignElectromotiveForceTest");
    int offset=0x01 << startForeignElectromotiveForceTest;
    if(index == 0)
    {
#if 0    /* #UnihanBU6# , Ailsa_cai , 20090401, fixed If line1 do the testing, line2 record not be erased */
        if ((linetest == 0)&&(testid & offset))
#else
        if ((testid1 !=0 )&&(testid1 & offset))
#endif			
        {
            websWrite(wp,"%s",line1_item_value[startForeignElectromotiveForceTest]);
        }
        else
        {
            websWrite(wp,"%s","not selected");
        }
    }
    else if(index == 1)
    {   
#if 0    /* #UnihanBU6# , Ailsa_cai , 20090401, fixed If line1 do the testing, line2 record not be erased */
        if ((linetest == 1)&&(testid & offset))
#else
        if ((testid2 !=0 )&&(testid2 & offset))
#endif
        {
            websWrite(wp,"%s",line2_item_value[startForeignElectromotiveForceTest]);
        }
        else
        {
            websWrite(wp,"%s","not selected");
        }
    }
    return 0;
}

int LINETEST_get_startReceiverOffhook(webs_t wp,char_t *name)
{
    int index = get_code_index(name,"startReceiverOffhook");
    int offset = 0x01 << startReceiverOffhook;
/* #UnihanBU6# , Jimmy, 20080410, fix the ReceiverOffhook show test result issue */
    if(index == 0)
    {
#if 0    /* #UnihanBU6# , Ailsa_cai , 20090401, fixed If line1 do the testing, line2 record not be erased */
        if ((linetest == 0)&&(testid & offset))
#else
        if ((testid1 !=0 )&&(testid1 & offset))
#endif			
        {
            websWrite(wp,"%s",line1_item_value[startReceiverOffhook]);
        }
        else
        {
            websWrite(wp,"%s","not selected");
        }
    }
    else if(index == 1)
    {   
#if 0    /* #UnihanBU6# , Ailsa_cai , 20090401, fixed If line1 do the testing, line2 record not be erased */
        if ((linetest == 1)&&(testid & offset))
#else
        if ((testid2 !=0 )&&(testid2 & offset))
#endif
        {
            websWrite(wp,"%s",line2_item_value[startReceiverOffhook]);
        }
        else
        {
            websWrite(wp,"%s","not selected");
        }
    }
    return 0;

}

STATUS LINETEST_set_LineTestReset(webs_t wp, char_t *name)
{
    int linereset=atoi(websGetVar(wp,"linereset",""));
    int rc;
    if(linereset != TEST_BOTH)
    {
        rc = VOIM_set_config_param( NMM_XGCP_LINE_RESET, linereset, 1, 0, NULL , 0 );
        if (rc != OK)
        {
            printf("Line %d can't reset!\n",linereset);
        } 
    }
    else 
    {
        rc = VOIM_set_config_param( NMM_XGCP_LINE_RESET, 0, 1, 0, NULL , 0 );
        if(rc != OK)
        {
            printf("Line 0 can't reset!\n");
        }
        rc = VOIM_set_config_param( NMM_XGCP_LINE_RESET, 1, 1, 0, NULL , 0 );
        if(rc != OK)
        {
            printf("Line   1 can't reset!\n");
        }
    }
    return OK;
}

/* #UnihanBU6#, Chenwin_Qiu, 20090401, implement record last test time. Start */
int LINETEST_get_lastTestTime(webs_t wp,char_t *name)
{
    /* #UnihanBU6#, Chenwin_Qiu, 2009/04/10, record test time line 1 and line2 apart. */
    int index=get_code_index(name,"startRecordLastTestTime");
    unsigned long lastTestTime;
	
    /* #UnihanBU6#, Chenwin_Qiu, 2009/04/10, record test time line 1 and line2 apart. */
    if(System_ShmDb_GetLastTestTime(&lastTestTime, index) == NOK)
    {
        websWrite("%s", "unknown");
        return -1;
    }
    else
    {
        if(lastTestTime<MIDNIGHT_JAN_01_2000)
        {
            websWrite(wp,"%s","--:--:--:--:--:--");
        }
        else
        {
            websWrite(wp,"%s",ctime(&lastTestTime));
        }
        return 0;
    }		 
}
/* #UnihanBU6#, Chenwin_Qiu, 20090401, implement record last test time. End */



