/*
 * CGI helper functions
 *
 * Copyright 2003, Broadcom Corporation
 * All Rights Reserved.                
 *                                     
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Broadcom Corporation;   
 * the contents of this file may not be disclosed to third parties, copied
 * or duplicated in any form, in whole or in part, without the prior      
 * written permission of Broadcom Corporation.
 *
 * $Id: mta.c,v 1.1.1.1 2010/06/30 06:49:33 eating Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "httpd.h"
#include "pacm_prov_db.h"
#include "hal_db.h"
#include "vendor_common_utils.h"
#include "sys_dflt.h"

#define PACM_MAX_STRING_LEN 256
#define PACM_FILENAME_STRING_LEN 128
#define CODEWORD_MAX_LEN 10
#define DHCP_SECONDS  (60*60*24)
#define DHCP_TIME_MAX_LEN 32
/* #UnihanBU6#, Chenwin_Qiu, 20090407, Add for fixing time displaying format */
#define MAX_REP_STR 256

int MTA_Handle(int eid, webs_t wp, int argc, char_t **argv);
int MTA_get_DhcpLeaseTime(webs_t wp,char_t *name);
int MTA_get_DhcpRebindTime(webs_t wp,char_t *name);
int MTA_get_DhcpRenewTime(webs_t wp,char_t *name);
int MTA_get_FQDN(webs_t wp,char_t *name);
int MTA_get_IpAddress(webs_t wp,char_t *name);
int MTA_get_SubnetMask(webs_t wp,char_t *name);
int MTA_get_Gateway(webs_t wp,char_t *name);
int MTA_get_ConfigFileName(webs_t wp,char_t *name);
int MTA_get_PrimaryDNS(webs_t wp,char_t *name);
int MTA_get_SecondaryDNS(webs_t wp,char_t *name);
int MTA_get_DhcpSuboptionType(webs_t wp,char_t *name);
int MTA_get_DhcpSuboption3(webs_t wp,char_t *name);
int MTA_get_DhcpSuboption6(webs_t wp,char_t *name);
int MTA_get_DhcpSuboption7(webs_t wp,char_t *name);
int MTA_get_DhcpSuboption8(webs_t wp,char_t *name);

int MTA_get_UnerrorCode(webs_t wp,char_t *name);
int MTA_get_UncorrectCode(webs_t wp,char_t *name);
int MTA_get_CorrectCode(webs_t wp,char_t *name);

int MTA_get_ConfigfileContent(webs_t wp,char_t *name);
int MTA_get_PrivateMibs(webs_t wp,char_t *name);
int MTA_get_TelephonyState(webs_t wp,char_t *name);

/* #UnihanBU6#, Ailsa_Cai , 20090403 , add information for mta in adv_dhcp.asp ,Start*/
int MTA_get_TftpServer(webs_t wp,char_t *name);
/* #UnihanBU6#, Ailsa_Cai , 20090403 , End */

/*#UnihanBU6, Alisa_Gao, 2009/04/07,Impement UI show Last 20 calls MCGP Msg*/
int MTA_get_LastCallsMessage(webs_t wp,char_t *name);

/* #UnihanBU6#,Rainy_yuan, 20080904, define priv mib need to show on UI.  */
char *priv_mib[]=
{
    "1.3.6.1.4.1.4526.3.1.13.1.14.1.0",
    "1.3.6.1.4.1.4526.3.1.13.1.14.2.0",
    "1.3.6.1.4.1.4526.3.1.13.1.14.3.0",
    "1.3.6.1.4.1.4526.3.1.13.1.14.4.0",
    "1.3.6.1.4.1.4526.3.1.13.1.14.5.0",
    "1.3.6.1.4.1.4526.3.1.13.1.14.6.0",
    "1.3.6.1.4.1.4526.3.1.13.1.14.7.0",
    "1.3.6.1.4.1.4526.3.1.13.1.14.8.0",
    "1.3.6.1.4.1.4526.3.1.13.1.14.9.0",
    "1.3.6.1.4.1.4526.3.1.13.1.14.10.0",
    "1.3.6.1.4.1.4526.3.1.13.1.14.11.0",
    "1.3.6.1.4.1.4526.3.1.13.1.14.12.0",	
    "1.3.6.1.4.1.4526.3.1.13.1.14.13.0",
    "1.3.6.1.4.1.4526.3.1.13.1.14.14.0",
    "1.3.6.1.4.1.4526.3.1.13.1.14.15.0",
    "1.3.6.1.4.1.4526.3.1.13.1.14.16.0",
    "1.3.6.1.4.1.4526.3.1.13.1.14.17.0",
    "1.3.6.1.4.1.4526.3.1.13.1.14.18.0",
    "1.3.6.1.4.1.4526.3.1.13.1.14.19.1.1.9",
    "1.3.6.1.4.1.4526.3.1.13.1.14.19.1.1.10",
    "1.3.6.1.4.1.4526.3.1.13.1.14.19.1.2.9",
    "1.3.6.1.4.1.4526.3.1.13.1.14.19.1.2.10",
    "1.3.6.1.4.1.4526.3.1.13.1.14.19.1.3.9",
    "1.3.6.1.4.1.4526.3.1.13.1.14.19.1.3.10",
    "1.3.6.1.4.1.4526.3.1.13.1.14.19.1.4.9",
    "1.3.6.1.4.1.4526.3.1.13.1.14.19.1.4.10",
    "1.3.6.1.4.1.4526.3.1.13.1.14.20.0",
	NULL
};

char *priv_mibName[]=
{
    "emtaPhsConfiguration",
    "emtaPhsUpstreamMask",
    "emtaPhsDownstreamMask",
    "emtaEcanTailLengthEnhance",
    "emtaVADControl",
    "emtaCNGControl",
    "emtaSignalingVoiceJitterBufferType",
    "emtaSignalingVoiceJitterNomValue",
    "emtaSignalingVoiceJitterMinValue",
    "emtaSignalingVoiceJitterMaxValue",
    "emtaDtmfRelay",
    "emtaSignalingRtcpDSCP",
    "emtaSignalingRtpDSCP",
    "emtaSignalingSnmpDSCP",
    "emtaSignalingMgcpDSCP",
    "emtaEndptDeviceControl",
    "emtaOffHookResetDelay",
    "emtaCmsConnectionStatus",
    "emtaStatsEndptHookState.9",
    "emtaStatsEndptHookState.10",
    "emtaStatsEndptQuarantineState.9",
    "emtaStatsEndptQuarantineState.10",
    "emtaStatsEndptSlicOverTempStatus.9",
    "emtaStatsEndptSlicOverTempStatus.10",
    "emtaStatsEndptOverCurrentStatus.9",
    "emtaStatsEndptOverCurrentStatus.10",
    "emtaTodRenewalInterval",
    NULL
};

struct cgi_handler MTA_handlers[]=
{
    {"lease",MTA_get_DhcpLeaseTime},
    {"rebind",MTA_get_DhcpRebindTime},
    {"renew", MTA_get_DhcpRenewTime},
    {"fqdn",MTA_get_FQDN},
    {"ipaddr",MTA_get_IpAddress},
    {"subnetmask",MTA_get_SubnetMask},
    {"gateway",MTA_get_Gateway},
    {"bootfile",MTA_get_ConfigFileName},
    {"primarydns",MTA_get_PrimaryDNS},
    {"seconddns",MTA_get_SecondaryDNS},
    {"subopt_type",MTA_get_DhcpSuboptionType},
    {"subopt3",MTA_get_DhcpSuboption3},
    {"subopt6",MTA_get_DhcpSuboption6},
    {"subopt7", MTA_get_DhcpSuboption7},
    {"subopt8",MTA_get_DhcpSuboption8},
	
    {"unerror_code0",MTA_get_UnerrorCode},
    {"unerror_code1",MTA_get_UnerrorCode},
    {"unerror_code2",MTA_get_UnerrorCode},
    {"unerror_code3",MTA_get_UnerrorCode},

    {"uncorrect_code0",MTA_get_UncorrectCode},
    {"uncorrect_code1",MTA_get_UncorrectCode},
    {"uncorrect_code2",MTA_get_UncorrectCode},
    {"uncorrect_code3",MTA_get_UncorrectCode},

    {"correct_code0", MTA_get_CorrectCode},
    {"correct_code1", MTA_get_CorrectCode},
    {"correct_code2", MTA_get_CorrectCode},
    {"correct_code3", MTA_get_CorrectCode},
	

    {"configfile_content",MTA_get_ConfigfileContent},
    {"priv_mibs",MTA_get_PrivateMibs},
    {"line1",MTA_get_TelephonyState},
    {"line2",MTA_get_TelephonyState},
/* #UnihanBU6#, Ailsa_Cai , 20090403 , add information for mta in adv_dhcp.asp ,Start*/
    {"tftp_server",MTA_get_TftpServer},
/* #UnihanBU6#, Ailsa_Cai , 20090403 , End */
 /*#UnihanBU6, Alisa_Gao, 2009/04/07,Impement UI show Last 20 calls MCGP Msg*/
    {"lastCallsMessage",MTA_get_LastCallsMessage},
    {NULL,NULL}
};

char DhcpOptionType[][8]=
{
    "unknow",
    "122",
    "177"
};

int MTA_Handle(int eid, webs_t wp, int argc, char_t **argv)
{
    char_t*name;
    struct cgi_handler *handler;
	
    if(PACM_Prov_DbRetrieveAccess()==NOK)
    {
        websWrite(wp,"%s","unknow");
        return -1;
    }
    if(Common_Utils_init()==NOK)
    {
        websWrite(wp,"%s","unknow");
        return -1;
    }
    if (HAL_GlobalRegistration(1) == NOK )
    {
        websWrite(wp, "unknown");
        return -1;
    }
    if(ejArgs(argc,argv,"%s",&name)<1)
    {
        websError(wp,400,"Insufficient args\n");
        return -1;
    }
	
    for(handler=&MTA_handlers[0];handler->pattern;handler++)
    {
        if(strncmp(handler->pattern,name,strlen(handler->pattern))==0)
            handler->output(wp,name);
    }
    return 0;
}

void  get_MTA_DaysAndSeconds(Uint32 *time,char *DaysSeconds)
{
    Uint32 days=(*time)/(DHCP_SECONDS);
    Uint32 seconds=(*time)%(DHCP_SECONDS);
    sprintf(DaysSeconds,"%u Days %u Seconds",days,seconds);
}

int MTA_get_DhcpLeaseTime(webs_t wp,char_t *name)
{	
    Uint32 MtaDhcpLeaseRemainTime = 0;
    double totaldays;
    int days;    
    int hours;    
    int minutes;    
    int seconds;    
    int remainder;    
    char time[MAX_REP_STR];	    
    memset(time,0,MAX_REP_STR);
    
    if(Common_Utils_GetMtaDhcpLeaseRemainTime(&MtaDhcpLeaseRemainTime) == STATUS_OK)
    {
        /* #UnihanBU6#, Chenwin_Qiu, 20090407, Fix display MtaDhcpLeaseRemainTime format */
        totaldays = MtaDhcpLeaseRemainTime/(24.0*60.0*60.0);
        days = MtaDhcpLeaseRemainTime/(24*60*60);
        remainder = MtaDhcpLeaseRemainTime % (24*60*60);
        hours = remainder/(60*60);
        remainder %= (60*60);
        minutes = remainder/(60);
        remainder %= (60);
        seconds = remainder;
        sprintf(time,"%1d days, %02dh, %02dm, %02ds",days,hours,minutes,seconds);
        websWrite(wp,"Days:%3.1f<br>&nbspSeconds: %u<br>&nbsp%s",totaldays,MtaDhcpLeaseRemainTime,time);
    }
    else
    {
        websWrite(wp,"%s","unknow");
    }
    return 0;
}

int MTA_get_DhcpRebindTime(webs_t wp,char_t *name)
{
    Uint32 MtaDhcpRebindRemainTime = 0;
    double totaldays;
    int days;    
    int hours;    
    int minutes;    
    int seconds;    
    int remainder;    
    char time[MAX_REP_STR];	    
    memset(time,0,MAX_REP_STR);
    
    if(Common_Utils_GetMtaDhcpRebindRemainTime(&MtaDhcpRebindRemainTime) == STATUS_OK)
    {
        /* #UnihanBU6#, Chenwin_Qiu, 20090407, Fix display MtaDhcpRebindRemainTime format */
        totaldays = MtaDhcpRebindRemainTime/(24.0*60.0*60.0);
        days = MtaDhcpRebindRemainTime/(24*60*60);
        remainder = MtaDhcpRebindRemainTime % (24*60*60);
        hours = remainder/(60*60);
        remainder %= (60*60);
        minutes = remainder/(60);
        remainder %= (60);
        seconds = remainder;
        sprintf(time,"%1d days, %02dh, %02dm, %02ds",days,hours,minutes,seconds);
        websWrite(wp,"Days:%3.1f<br>&nbspSeconds: %u<br>&nbsp%s",totaldays,MtaDhcpRebindRemainTime,time);
    }
    else
    {
        websWrite(wp,"%s","unknow");
    }
    return 0;
}
int MTA_get_DhcpRenewTime(webs_t wp,char_t *name)
{
    Uint32 MtaDhcpRenewRemainTime = 0;
    double totaldays;
    int days;    
    int hours;    
    int minutes;    
    int seconds;    
    int remainder;    
    char time[MAX_REP_STR];	    
    memset(time,0,MAX_REP_STR);
    
    if(Common_Utils_GetMtaDhcpRenewRemainTime(&MtaDhcpRenewRemainTime)==STATUS_OK)
    {
        /* #UnihanBU6#, Chenwin_Qiu, 20090407, Fix display MtaDhcpRebindRemainTime format */
        totaldays = MtaDhcpRenewRemainTime/(24.0*60.0*60.0);
        days = MtaDhcpRenewRemainTime/(24*60*60);
        remainder = MtaDhcpRenewRemainTime % (24*60*60);
        hours = remainder/(60*60);
        remainder %= (60*60);
        minutes = remainder/(60);
        remainder %= (60);
        seconds = remainder;
        sprintf(time,"%1d days, %02dh, %02dm, %02ds",days,hours,minutes,seconds);
        websWrite(wp,"Days:%3.1f<br>&nbspSeconds: %u<br>&nbsp%s",totaldays,MtaDhcpRenewRemainTime,time);
    }
    else
    {
        websWrite(wp,"%s","unknow");
    }
    return 0;
}
int MTA_get_FQDN(webs_t wp,char_t *name)
{
    char fqdn[PACM_MAX_STRING_LEN];
    memset(fqdn,0,PACM_MIB_MAX_STRING_LEN);
    if(PACM_Prov_GetMtaDevFQDN(fqdn,PACM_MAX_STRING_LEN)==STATUS_OK)
    {
        websWrite(wp,"%s",fqdn);
    }
    else 
    {
        websWrite(wp,"%s","unknow");
    }
    return 0;
}

int MTA_get_IpAddress(webs_t wp,char_t *name)
{
    InetAddr_t mtaIPAddr;
    char dottedAddress[INET_ADDRSTRLEN];
    memset(dottedAddress,0,INET_ADDRSTRLEN);
    if(PACM_Prov_GetMtaDevIpAddress(&mtaIPAddr)==STATUS_OK)
    {
        inet_ntop(AF_INET, mtaIPAddr.addr, dottedAddress, INET_ADDRSTRLEN);
        websWrite(wp,"%s",dottedAddress);
    }
    else 
    {
        websWrite(wp,"%s","------");
    }
    return 0;
}

int MTA_get_SubnetMask(webs_t wp,char_t *name)
{
    Uint32 SubnetMask;
    char IpStrBuff[INET_ADDRSTRLEN];
    memset(IpStrBuff,0,INET_ADDRSTRLEN);
	 
    if(Common_Utils_GetMTADevSubnetMask(&SubnetMask)==STATUS_OK)
    {	
        inet_ntop(AF_INET, &SubnetMask, IpStrBuff, INET_ADDRSTRLEN);
        websWrite(wp,"%s",IpStrBuff);
    }
    else
    {
        websWrite(wp,"%s","------");
    }
    return 0;
}

int MTA_get_Gateway(webs_t wp,char_t *name)
{
    Uint32 DefaultGw;
    char IpStrBuff[16];
    memset(IpStrBuff,0,16);
    if(Common_Utils_GetMTADevDefaultGW(&DefaultGw)==STATUS_OK)
    {
        inet_ntop(AF_INET, &DefaultGw, IpStrBuff, sizeof(IpStrBuff));
        websWrite(wp,"%s",IpStrBuff);
    }
    else
    {
        websWrite(wp,"%s","------");
    }
    return 0;
}
int MTA_get_ConfigFileName(webs_t wp,char_t *name)
{
    char configFilename[PACM_FILENAME_STRING_LEN];
    memset(configFilename,0,PACM_FILENAME_STRING_LEN);
    if(PACM_Prov_GetMtaDevConfigurationFileURL(configFilename)==STATUS_OK)
    {
        websWrite(wp,"%s",configFilename);
    }
    else
    {
        websWrite(wp,"%s","unknow");
    }
    return 0;
}
int MTA_get_PrimaryDNS(webs_t wp,char_t *name)
{
    InetAddr_t addr;
    char dottedAddress[INET_ADDRSTRLEN];
    memset(dottedAddress,0,INET_ADDRSTRLEN);
    if(PACM_Prov_GetServerIpAddress(&addr,PACM_MTA_DEV_SRV_DNS1)==STATUS_OK)
    {	
        inet_ntop(AF_INET, addr.addr, dottedAddress, INET_ADDRSTRLEN);
        websWrite(wp,"%s",dottedAddress);		
    }
	
    else
    {
        websWrite(wp,"%s","------");
    }
    return 0;
}
int MTA_get_SecondaryDNS(webs_t wp,char_t *name)
{
    InetAddr_t addr;
    char dottedAddress[INET_ADDRSTRLEN];
    memset(dottedAddress,0,INET_ADDRSTRLEN);
    if(PACM_Prov_GetServerIpAddress(&addr,PACM_MTA_DEV_SRV_DNS2)==STATUS_OK)
    {	
        inet_ntop(AF_INET, addr.addr, dottedAddress, INET_ADDRSTRLEN);
        websWrite(wp,"%s",dottedAddress);
    }
    else 
    {
        websWrite(wp,"%s","------");
    }
    return 0;
}



int MTA_get_DhcpSuboptionType(webs_t wp,char_t *name)
{
    PktcDhcpClientOptionType_e MtaDhcpClientOptionType;
    if(Common_Utils_GetMtaDhcpClientOptionType(&MtaDhcpClientOptionType) == STATUS_OK)
    {	
        websWrite(wp,"%s",DhcpOptionType[MtaDhcpClientOptionType]);
    }
    else
    {
        websWrite(wp,"%s","unknow");
    }
    return 0;
}
int MTA_get_DhcpSuboption3(webs_t wp,char_t *name)
{
    char mtaDevSnmpEntity[PACM_MAX_STRING_LEN];
    memset(mtaDevSnmpEntity,0,PACM_MAX_STRING_LEN);
    if(PACM_Prov_GetMtaDevSnmpEntity(mtaDevSnmpEntity) == STATUS_OK)
    {	
        websWrite(wp,"%s",mtaDevSnmpEntity);
    }
    else
    {
        websWrite(wp,"%s","unknow");
    }
    return 0;
}
int MTA_get_DhcpSuboption6(webs_t wp,char_t *name)
{
    char realm[PACM_MAX_STRING_LEN];
    memset(realm,0,PACM_MAX_STRING_LEN);
    if(Common_Utils_GetKerberosRealm(realm) == STATUS_OK)
    {
        websWrite(wp,"%s",realm);
    }
    else 
    {
        websWrite(wp,"%s","unknow");
    }
    return 0;
}
int MTA_get_DhcpSuboption7(webs_t wp,char_t *name)
{
    Uint8 tgt=0;
    if(Common_Utils_GetPktcMtaDevTgtUsage(&tgt) == STATUS_OK)
    {
        websWrite(wp,"%s",tgt==1?"True":"False");
    }
    else 
    {
        websWrite(wp,"%s","unknow");
    }
    return 0;
}
int MTA_get_DhcpSuboption8(webs_t wp,char_t *name)
{
    Uint32 mtaDevProvisioningTimer=0;
    if (PACM_Prov_GetMtaDevProvisioningTimer(&mtaDevProvisioningTimer) == STATUS_OK)
    {
        websWrite(wp,"%u Minutes",mtaDevProvisioningTimer);
    }
    else
    {
        websWrite(wp,"%s","unknow");	
    }
    return 0;
}

int get_code_index(char *name, char *prex)
{
    char num[4];
    memset(num, 0, sizeof(num));
    strncpy(num, name+strlen(prex), 1);
    return atoi(num);
}

int MTA_get_UnerrorCode(webs_t wp,char_t *name)
{
    HalDb_CerCounter_t cerCounters;
    int index=get_code_index(name,"unerror_code");
    char unerrcode[CODEWORD_MAX_LEN];
    memset(unerrcode,0,CODEWORD_MAX_LEN);
    if(HalDb_UpdateCerCountersPerId(index) !=STATUS_OK)
    {
        return 0;
    }
    else
    {
        if(HalDb_GetCerCountersPerId(index,&cerCounters)==STATUS_OK)
        {
            if(cerCounters.sigQUnerrCwHigh!=0)
            {
                sprintf(unerrcode,"%u%u",cerCounters.sigQUnerrCwHigh,cerCounters.sigQUnerrCwLow);
            }
            else
            {
                sprintf(unerrcode,"%u",cerCounters.sigQUnerrCwLow);
            }
            websWrite(wp,"%s",unerrcode);
        }
        else 
        {
            websWrite(wp,"%s","unknow");
        }
    }
    return 0;	
}
int MTA_get_UncorrectCode(webs_t wp,char_t *name)
{
    HalDb_CerCounter_t cerCounters;
    int index=get_code_index(name,"uncorrect_code");
    char uncorrcode[CODEWORD_MAX_LEN ];
    memset(uncorrcode,0,CODEWORD_MAX_LEN);
    if(HalDb_UpdateCerCountersPerId(index)!=STATUS_OK)
    {
        return 0;
    }
    else
    {
        if(HalDb_GetCerCountersPerId(index,&cerCounters)==STATUS_OK)
        {
            if(cerCounters.sigQUncorreCwHigh!=0)
            {
                sprintf(uncorrcode,"%u%u",cerCounters.sigQUncorreCwHigh,cerCounters.sigQUncorreCwLow);
            }
            else
            {
                sprintf(uncorrcode,"%u",cerCounters.sigQUncorreCwLow);
            }
            websWrite(wp,"%s",uncorrcode);
        }
        else 
        {
            websWrite(wp,"%s","unknow");
        }
    }
    return 0;
}
int MTA_get_CorrectCode(webs_t wp,char_t *name)
{
    HalDb_CerCounter_t cerCounters;
    int index=get_code_index(name,"correct_code");
    char corrcode[CODEWORD_MAX_LEN ];
    memset(corrcode,0,CODEWORD_MAX_LEN);
    if(HalDb_UpdateCerCountersPerId(index)!=STATUS_OK)
    {
        return 0;
    }
    else
    {
        if(HalDb_GetCerCountersPerId(index,&cerCounters)==STATUS_OK)
        {
            if(cerCounters.sigQCorreCwHigh!=0)
            {
                sprintf(corrcode,"%u%u",cerCounters.sigQCorreCwHigh,cerCounters.sigQCorreCwLow);
            }
            else
            {
                sprintf(corrcode,"%u",cerCounters.sigQCorreCwLow);
            }
            websWrite(wp,"%s",corrcode);
        }
        else 
        {
            websWrite(wp,"%s","unknow");
        }
    }
    return 0;	
}

int MTA_get_ConfigfileContent(webs_t wp,char_t *name)
{
    /* #UnihanBU6#, Alisa_Gao, 20080710, implement CGI to get MTA and CM config file content */
    char configFileName[PACM_FILENAME_STRING_LEN];
    char outputPath[128];
    char *p;
    FILE *out;
    char inputPath[128];
    memset(inputPath,0,sizeof(inputPath));
    memset(configFileName,0,PACM_FILENAME_STRING_LEN);
    memset(outputPath,0,sizeof(outputPath));
    if(PACM_Prov_GetMtaDevConfigFileName(configFileName) == STATUS_OK)
    {  
        if(!strcmp(configFileName,""))
        {
            websWrite(wp,"%s","unknow");
            return 0;
        }
        while(1)
        {
            p = strstr(configFileName,"/");
            if (p == NULL)
                break;
            strcpy(configFileName,p+1);
        }
		
        sprintf(inputPath,"/var/tmp/%s",configFileName);
        sprintf(outputPath,SYS_DFLT_MTA_CFGCONTENT_FILE_PATH);
        /*change the config file to readable file,such as:/var/tmp/alisa_mta.cfg==>/var/tmp/mta_cfg.txt*/
        if(Common_Utils_GetConfigContent(inputPath,outputPath) == STATUS_OK)
        {
            char line[256];
            memset(line,0,sizeof(line));
            if((out=fopen(outputPath,"r+"))!= NULL)
            {
                while(!feof(out)&&fgets(line,sizeof(line),out))
                {
		 
                    websWrite(wp,"%s",line);
                    websWrite(wp,"<br>");
                }
                fclose(out);
                return 0;
            }
            else 
            {
                fprintf(stderr,"%s","Can't open the file,Error");
            }
        }	
    }
    websWrite(wp,"%s","unknow");
    return 0;
}

/* #UnihanBU6#,Rainy_yuan, 20080904, to show priv mibs.  */
int MTA_get_PrivateMibs(webs_t wp,char_t *name)
{
    int index=0;
    char snmpBuff[256];
    unsigned int remotePort;
    /* #UnihanBU6#, Energy_Yang, 2009/02/20 * Update the CVD31XT seed potd function and potd tools, ao all netgear project can use the same tool. */
    char seed[SYS_DFLT_HTTP_PASS_SEED_SIZE];
    char community_potd[SYS_DFLT_HTTP_PASS_SEED_POTD_SIZE];
    memset(community_potd,0,sizeof(community_potd));
    memset(seed,0,sizeof(seed));
    if (System_ShmDb_GetSnmpLocalHostPortForMta(&remotePort) == NOK)
    {
        /* can not get port */
        websWrite(wp,"<tr><td>unknow</td><td>unknow</td></tr>");
        return 0;
    }
    /* #UnihanBU6#,Rainy_yuan, 20080922, use POTD password as community.  */
    if(Common_Utils_GetHttpPasswordSeed(seed) == STATUS_NOK)
    {
        return 0;
    }
    if(Common_Utils_GetNetgearPasswordOfTheDay(seed,strlen(seed),community_potd,sizeof(community_potd)) == STATUS_NOK)
        return 0;

    while(priv_mib[index] != NULL)
    {
        memset(snmpBuff,0,256);
        if ( Common_Utils_Snmpget(priv_mib[index], community_potd, snmpBuff, 256, remotePort) == OK)
        {
            websWrite(wp,"<tr><td>%s</td><td>%s</td></tr>",priv_mibName[index],snmpBuff);
        }
        else 
        {
            websWrite(wp,"<tr><td>%s</td><td>%s</td></tr>",priv_mibName[index],"unknow");
        }
        index++ ;
    }
    return 1;
}

int MTA_get_TelephonyState(webs_t wp,char_t *name)
{
    int index=get_code_index(name,"line");
    char HookStatus[32];
    memset(HookStatus,0,sizeof(HookStatus));
    if(Common_Utils_GetEndptStatus((index-1),HookStatus) == STATUS_OK)
    {
        websWrite(wp,"%s",HookStatus);
    }
    else
    {
        websWrite(wp,"%s","unknow");
    }
    return 0;
}

/* #UnihanBU6#, Ailsa_Cai , 20090403 , add information for mta in adv_dhcp.asp ,Start*/
int MTA_get_TftpServer(webs_t wp,char_t *name)
{
    InetAddr_t ipAddress;    
    char addrStr[INET6_ADDRSTRLEN];
    memset(&ipAddress,0,sizeof(InetAddr_t));
    memset(addrStr,0,INET6_ADDRSTRLEN);
    if(PACM_Prov_GetServerIpAddress(&ipAddress, PACM_MTA_DEV_SRV_TFTP) == OK)
    {
        if(ipAddress.family == AF_INET)
        {
            inet_ntop( AF_INET, ipAddress.addr, addrStr, INET_ADDRSTRLEN);
        }
        else if(ipAddress.family == AF_INET6 )
        {
            inet_ntop( AF_INET, ipAddress.addr, addrStr, INET6_ADDRSTRLEN);
        }
        websWrite(wp,"%s",addrStr);
    }
    else
    {
        websWrite(wp,"----");
    }
    return 0;
}
/* #UnihanBU6#, Ailsa_Cai , 20090403 , End */

/*#UnihanBU6, Alisa_Gao, 2009/04/07,Impement UI show Last 20 calls MCGP Msg*/
int MTA_get_LastCallsMessage(webs_t wp,char_t *name)
{
	int i=0;
	unsigned char fLastCallsNCSMsg[SYS_DFLT_LastNCSMsgSend_SIZE];
	unsigned int direction = -1;
	memset(fLastCallsNCSMsg,0,sizeof(SYS_DFLT_LastNCSMsgSend_SIZE));
	for(i = 0;i<SYS_DFLT_LAST_NCS_CALLS;i++)
	{
	    if((System_ShmDb_GetLastCallsNCSMsg(i, fLastCallsNCSMsg) == OK))
	    {
              if(strlen(fLastCallsNCSMsg)!=0)
              {
                  if(System_ShmDb_GetLastCallsNCSMsgDirection(i,&direction) == NOK)
                  {
                      direction = -1;
                  }
                	websWrite(wp,"<tr><td>%d</td><td>%s</td><td>%s</td></tr>",(i+1),(direction?"Receive":"Send"),fLastCallsNCSMsg);
                }
	    }
	}
	return 0;
}
 /*#UnihanBU6, Alisa_Gao, 2009/04/07,Impement UI show Last 20 calls MCGP Msg,End*/
