/*
 * CGI helper functions
 *
 * Copyright 2003, Broadcom Corporation
 * All Rights Reserved.                
 *                                     
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Broadcom Corporation;   
 * the contents of this file may not be disclosed to third parties, copied
 * or duplicated in any form, in whole or in part, without the prior      
 * written permission of Broadcom Corporation.                            
 *
 * $Id: qos.c,v 1.1.1.1 2010/06/30 06:49:33 eating Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "httpd.h"
#include "vendor_common_utils.h"
#include "qos_main_db.h"


int QOS_Handle(int eid, webs_t wp, int argc, char_t **argv);
int QOS_get_PhsState(webs_t wp,char_t *name);
int QOS_SfTableShow(webs_t wp,char_t *name);

struct cgi_handler QOS_handlers[]=
{
    {"phs_state",QOS_get_PhsState},
    {"sf_show",QOS_SfTableShow},
    {NULL,NULL}
};


int QOS_Handle(int eid, webs_t wp, int argc, char_t **argv)
{
    char_t*name;
    struct cgi_handler *handler;
    
    if(Common_Utils_init() == NOK )
    {
        websWrite(wp, "unknown");
        return -1;
    }
    
    if(qos_mainDb_RetrieveAccess() == NOK )
    {
        websWrite(wp, "unknown");
        return -1;
    }
    
    if(ejArgs(argc,argv,"%s",&name)<1)
    {
        websError(wp,400,"Insufficient args\n");
        return -1;
    }
    
    for(handler=&QOS_handlers[0];handler->pattern;handler++)
    {
        if(strncmp(handler->pattern,name,strlen(handler->pattern))==0)
            handler->output(wp,name);
    }
    return 0;
}

int QOS_get_PhsState(webs_t wp,char_t *name)
{
    unsigned char PhsState=0;
    if (Common_Utils_GetEnableRtpPhs(&PhsState) == OK)
    {
        if (PhsState == 0)
            websWrite(wp,"OFF");
        else if (PhsState == 1)
            websWrite(wp,"ON");
        else
            websWrite(wp,"unknow");
    }
    else
    {
        websWrite(wp,"unknow");
    }
    return 0;
}

int QOS_SfTableShow(webs_t wp,char_t *name)
{
    INDEX_TYPE index;
    DB_QOS_ServiceFlowType sfPtr;
    Int8  sfName[QOS_SCNAME_MAX_SIZE];
    memset(sfName,0,sizeof(sfName));
    for (index = 0; index < QOS_MAX_SFID_NUMBER; index++) 
    {
        if( qos_mainDb_GetServiceFlowByIndex (index,&sfPtr) == QOS_DB_SUCCESS )
        {
        /* #UnihanBU6#, Allen, 20081202, The QoS Direction in QoS page should not show "downstream" always */
            if(get_className_Name(index,sfName) == NOK)
            {
                strcpy(sfName,"");/*if sfName is not got successfully,make it empty*/
            }
            websWrite(wp,"<tr><td>&nbsp;%d</td><td>&nbsp;%s</td><td>&nbsp;%s</td><td>&nbsp;%s</td><td>&nbsp;%d</td></tr>",sfPtr.SFID,sfName,(sfPtr.Direction==QOS_DOWNSTREAM)?"downstream":"upstream",(sfPtr.isPrimary)?"Yes":"No",sfPtr.pktCounter);
        }
    }
    return 0;
}
